// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dataspeed_dbw_gateway:msg/DynamicArrays.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_DBW_GATEWAY__MSG__DETAIL__DYNAMIC_ARRAYS__TRAITS_HPP_
#define DATASPEED_DBW_GATEWAY__MSG__DETAIL__DYNAMIC_ARRAYS__TRAITS_HPP_

#include "dataspeed_dbw_gateway/msg/detail/dynamic_arrays__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 't_message'
#include "dataspeed_dbw_gateway/msg/detail/example_message__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const dataspeed_dbw_gateway::msg::DynamicArrays & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: t_float
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_float.size() == 0) {
      out << "t_float: []\n";
    } else {
      out << "t_float:\n";
      for (auto item : msg.t_float) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_double
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_double.size() == 0) {
      out << "t_double: []\n";
    } else {
      out << "t_double:\n";
      for (auto item : msg.t_double) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_char
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_char.size() == 0) {
      out << "t_char: []\n";
    } else {
      out << "t_char:\n";
      for (auto item : msg.t_char) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_bool
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_bool.size() == 0) {
      out << "t_bool: []\n";
    } else {
      out << "t_bool:\n";
      for (auto item : msg.t_bool) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_octet
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_octet.size() == 0) {
      out << "t_octet: []\n";
    } else {
      out << "t_octet:\n";
      for (auto item : msg.t_octet) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        character_value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_u8
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_u8.size() == 0) {
      out << "t_u8: []\n";
    } else {
      out << "t_u8:\n";
      for (auto item : msg.t_u8) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_i8
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_i8.size() == 0) {
      out << "t_i8: []\n";
    } else {
      out << "t_i8:\n";
      for (auto item : msg.t_i8) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_u16
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_u16.size() == 0) {
      out << "t_u16: []\n";
    } else {
      out << "t_u16:\n";
      for (auto item : msg.t_u16) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_i16
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_i16.size() == 0) {
      out << "t_i16: []\n";
    } else {
      out << "t_i16:\n";
      for (auto item : msg.t_i16) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_u32
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_u32.size() == 0) {
      out << "t_u32: []\n";
    } else {
      out << "t_u32:\n";
      for (auto item : msg.t_u32) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_i32
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_i32.size() == 0) {
      out << "t_i32: []\n";
    } else {
      out << "t_i32:\n";
      for (auto item : msg.t_i32) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_u64
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_u64.size() == 0) {
      out << "t_u64: []\n";
    } else {
      out << "t_u64:\n";
      for (auto item : msg.t_u64) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_i64
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_i64.size() == 0) {
      out << "t_i64: []\n";
    } else {
      out << "t_i64:\n";
      for (auto item : msg.t_i64) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_string
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_string.size() == 0) {
      out << "t_string: []\n";
    } else {
      out << "t_string:\n";
      for (auto item : msg.t_string) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_wstring
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_wstring.size() == 0) {
      out << "t_wstring: []\n";
    } else {
      out << "t_wstring:\n";
      for (auto item : msg.t_wstring) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_bounded_string
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_bounded_string.size() == 0) {
      out << "t_bounded_string: []\n";
    } else {
      out << "t_bounded_string:\n";
      for (auto item : msg.t_bounded_string) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_bounded_wstring
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_bounded_wstring.size() == 0) {
      out << "t_bounded_wstring: []\n";
    } else {
      out << "t_bounded_wstring:\n";
      for (auto item : msg.t_bounded_wstring) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: t_message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.t_message.size() == 0) {
      out << "t_message: []\n";
    } else {
      out << "t_message:\n";
      for (auto item : msg.t_message) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const dataspeed_dbw_gateway::msg::DynamicArrays & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<dataspeed_dbw_gateway::msg::DynamicArrays>()
{
  return "dataspeed_dbw_gateway::msg::DynamicArrays";
}

template<>
inline const char * name<dataspeed_dbw_gateway::msg::DynamicArrays>()
{
  return "dataspeed_dbw_gateway/msg/DynamicArrays";
}

template<>
struct has_fixed_size<dataspeed_dbw_gateway::msg::DynamicArrays>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<dataspeed_dbw_gateway::msg::DynamicArrays>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<dataspeed_dbw_gateway::msg::DynamicArrays>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DATASPEED_DBW_GATEWAY__MSG__DETAIL__DYNAMIC_ARRAYS__TRAITS_HPP_
