// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dataspeed_dbw_gateway:msg/Types.idl
// generated code does not contain a copyright notice

#ifndef DATASPEED_DBW_GATEWAY__MSG__DETAIL__TYPES__TRAITS_HPP_
#define DATASPEED_DBW_GATEWAY__MSG__DETAIL__TYPES__TRAITS_HPP_

#include "dataspeed_dbw_gateway/msg/detail/types__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 't_message'
#include "dataspeed_dbw_gateway/msg/detail/example_message__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const dataspeed_dbw_gateway::msg::Types & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: t_float
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_float: ";
    value_to_yaml(msg.t_float, out);
    out << "\n";
  }

  // member: t_double
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_double: ";
    value_to_yaml(msg.t_double, out);
    out << "\n";
  }

  // member: t_char
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_char: ";
    value_to_yaml(msg.t_char, out);
    out << "\n";
  }

  // member: t_bool
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_bool: ";
    value_to_yaml(msg.t_bool, out);
    out << "\n";
  }

  // member: t_octet
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_octet: ";
    character_value_to_yaml(msg.t_octet, out);
    out << "\n";
  }

  // member: t_u8
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_u8: ";
    value_to_yaml(msg.t_u8, out);
    out << "\n";
  }

  // member: t_i8
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_i8: ";
    value_to_yaml(msg.t_i8, out);
    out << "\n";
  }

  // member: t_u16
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_u16: ";
    value_to_yaml(msg.t_u16, out);
    out << "\n";
  }

  // member: t_i16
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_i16: ";
    value_to_yaml(msg.t_i16, out);
    out << "\n";
  }

  // member: t_u32
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_u32: ";
    value_to_yaml(msg.t_u32, out);
    out << "\n";
  }

  // member: t_i32
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_i32: ";
    value_to_yaml(msg.t_i32, out);
    out << "\n";
  }

  // member: t_u64
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_u64: ";
    value_to_yaml(msg.t_u64, out);
    out << "\n";
  }

  // member: t_i64
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_i64: ";
    value_to_yaml(msg.t_i64, out);
    out << "\n";
  }

  // member: t_string
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_string: ";
    value_to_yaml(msg.t_string, out);
    out << "\n";
  }

  // member: t_wstring
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_wstring: ";
    value_to_yaml(msg.t_wstring, out);
    out << "\n";
  }

  // member: t_bounded_string
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_bounded_string: ";
    value_to_yaml(msg.t_bounded_string, out);
    out << "\n";
  }

  // member: t_bounded_wstring
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_bounded_wstring: ";
    value_to_yaml(msg.t_bounded_wstring, out);
    out << "\n";
  }

  // member: t_message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_message:\n";
    to_yaml(msg.t_message, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const dataspeed_dbw_gateway::msg::Types & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<dataspeed_dbw_gateway::msg::Types>()
{
  return "dataspeed_dbw_gateway::msg::Types";
}

template<>
inline const char * name<dataspeed_dbw_gateway::msg::Types>()
{
  return "dataspeed_dbw_gateway/msg/Types";
}

template<>
struct has_fixed_size<dataspeed_dbw_gateway::msg::Types>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<dataspeed_dbw_gateway::msg::Types>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<dataspeed_dbw_gateway::msg::Types>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DATASPEED_DBW_GATEWAY__MSG__DETAIL__TYPES__TRAITS_HPP_
